/* ScreetArgumentList.cpp - List of arguments to a Screet method call */
/* Copyright 2002 Steve Folta */
/* See the "License" file */

#include "ScreetArgumentList.h"


void ScreetArgumentList::clear()
{
	Link* curLink = first;
	while (curLink) {
		Link* nextLink = curLink->next;
		delete curLink;
		curLink = nextLink;
		}
	first = last = NULL;
	numArgs = 0;
}


void ScreetArgumentList::addArgument(ScreetString arg)
{
	Link* newLink = new Link(arg);
	if (last)
		last->next = newLink;
	else
		first = newLink;
	last = newLink;
	++numArgs;
}


void ScreetArgumentList::buildVector(ScreetString* vector)
{
	int index = 0;
	for (Link* link = first; link; link = link->next, ++index) {
		vector[index] = link->arg;
		vector[index].semiDetach();
		}
}


void ScreetArgumentList::buildArgv(const char** argv)
{
	int index = 0;
	for (Link* link = first; link; link = link->next, ++index)
		argv[index] = link->arg.c_str();
}


void ScreetArgumentList::error(ScreetString err)
{
	clear();
	addArgument(err);
}



