/* ScreetArgumentList.h - List of arguments to a Screet method call */
/* Copyright 2002 Steve Folta */
/* See the "License" file */

#ifndef _ScreetArgumentList_h_
#define _ScreetArgumentList_h_

#include "ScreetString.h"


class ScreetArgumentList {
public:
	ScreetArgumentList() : first(NULL), last(NULL), numArgs(0) {}
	~ScreetArgumentList() { clear(); }

	void	addArgument(ScreetString arg);
	void	buildVector(ScreetString* vector);
	void	buildArgv(const char** argv);
	void	error(ScreetString err);
	int 	numArguments() { return numArgs; }
	bool	isError() { return (first && first->arg.startsWith("##!!")); }

	// only use this if isError() is true
	ScreetString	errorString() { return first->arg; }

protected:
	struct Link {
		ScreetString	arg;
		Link*       	next;

		Link(ScreetString argIn) : arg(argIn), next(NULL) {}
		};

	Link*	first;
	Link*	last;
	int  	numArgs;

	void	clear();
};



#endif
