/* ScreetContext.cpp -  */
/* Copyright 2002 Steve Folta */
/* See the "License" file */

#include "ScreetContext.h"


ScreetContext::ScreetContext(ScreetContext* parentContextIn)
	: first(NULL), parentContext(parentContextIn)
{
}


ScreetContext::~ScreetContext()
{
	// delete the whole list
	Link* curLink = first;
	while (curLink) {
		Link* nextLink = curLink->next;
		delete curLink;
		curLink = nextLink;
		}
}


void ScreetContext::set(ScreetString name, ScreetString value)
{
	// find the link with that name
	Link* link = NULL;
	for (Link* link = first; link; link = link->next) {
		if (link->name == name)
			break;
		}

	// if it was there, change it
	if (link)
		link->value = value;

	// if not, add it
	else {
		link = new Link(name, value);
		link->next = first;
		first = link;
		}
}


ScreetString ScreetContext::valueFor(ScreetString name)
{
	// find the link with that name
	Link* link = NULL;
	for (Link* link = first; link; link = link->next) {
		if (link->name == name)
			return link->value;
		}

	// if we don't have it, check the parent context
	if (parentContext)
		return parentContext->valueFor(name);

	// not found
	ScreetString errString = "##!! The variable named \"";
	errString += name;
	errString += "\" is not defined. !!##";
	return errString;
}


