/* ScreetListener.h - Handles Screet expressions on a TCP port. */
/* Copyright 2002 Steve Folta */
/* See the "License" file */

#ifndef _ScreetListener_h_
#define _ScreetListener_h_

#include "ScreetContext.h"


class ScreetListener {
public:
	ScreetListener(ScreetContext* outerContext = NULL, int port = 1998);
	~ScreetListener();
	bool	isValid();

	void	listen();
	void	handleConnection();
	bool	handleRequest(int connectionSocket);	// true => keep listening

protected:
	int          	listeningSocket;
	ScreetContext	screetContext;

	bool	requestIsComplete(char* buffer, int length);
};

/*
	Example:
		void MyThread::Execute()
		{
			ScreetListener screetListener;
			screetListener.listen();	// never returns
		}
*/


#endif
