/* ScreetMethodCall.Screetable.cpp - when using the Screetable interface */
/* Copyright 2002 Steve Folta */
/* See the "License" file */

#include "ScreetMethodCall.h"
#include "Screetable.h"


ScreetString screetMethodCall(void* object, ScreetString methodName,
                              int numArgs, ScreetString* args)
{
	// get the Screetable
	Screetable* screetable = dynamic_cast<Screetable*>((Screetable*) object);
	if (screetable == NULL) {
		ScreetString errorString = "##!! Attempt to call the method named \"";
		errorString += methodName;
		errorString += "\"on a non-object. !!##";
		return errorString;
		}

	// make the call
	return screetable->screetCall(methodName, numArgs, args);
}


void* screetObjectForString(ScreetString str)
{
	return (void*) Screetable::forString(str);
}


