/* ScreetStringStorage.h - Storage for a Screet string */
/* Copyright 2002 Steve Folta */
/* See the "License" file */

#ifndef _ScreetStringStorage_h_
#define _ScreetStringStorage_h_


class ScreetString;


class ScreetStringStorage {
public:
	ScreetStringStorage(const char* start, unsigned long length);
	ScreetStringStorage(const ScreetString& str1, const ScreetString& str2);
	~ScreetStringStorage();

	void	addReference() { ++refCount; }
	void	removeReference();

	const char* 	start() { return text; }
	const char* 	end() { return &text[size]; }
	unsigned long	length() { return size; }
	int         	referenceCount() { return refCount; }

protected:
	char*        	text;
	unsigned long	size;
	int          	refCount;
};


#endif
