/* Screetable.cpp - interface for Screet-accessible classes */
/* Copyright 2002 Steve Folta */
/* See the "License" file */

#include "Screetable.h"
#include <stdio.h>
#include <stdlib.h>


ScreetString Screetable::screetCall(ScreetString name, int numArgs,
                                    ScreetString* args)
{
	// default: it's not handled
	char numArgsStr[64];
	sprintf(numArgsStr, "%d", numArgs);
	return ScreetString("##!! Unknown function: \"") + name + "\" with " +
	       numArgsStr + " arguments. !!##";
}


ScreetString Screetable::asScreetString()
{
	char str[32];
	sprintf(str, "##0x%08X", this);
	ScreetString screetString(str);
	screetString.detach();
	return screetString;
}


Screetable* Screetable::forString(ScreetString str)
{
	if (str.substr(0, 4) != "##0x")
		return NULL;
	void* object = (void*) strtoul(str.substr(2, 10).c_str(), NULL, 16);
	if (object == NULL)
		return NULL;
	// try to verify that it is a Screetable.  Will this work?  Is it safe?
	return dynamic_cast<Screetable*>((Screetable*) object);
}


